'use strict';

var _require = require('./utils'),
    ONE_LETTER_OF_ALPHABET_E_TO_T = _require.ONE_LETTER_OF_ALPHABET_E_TO_T,
    TOKEN_TYPES = _require.TOKEN_TYPES,
    TWO_LETTERS_OF_ALPHABET_E_TO_T = _require.TWO_LETTERS_OF_ALPHABET_E_TO_T,
    lexer = _require.lexer,
    stringToArray = _require.stringToArray;

/**
 * 変換ロジックは以下であるが、これが正しいかは不明。
 * 1)2文字アルファベットの置換ができる場所を、先頭から優先して探して置換
 * 2)残ったテキストを1文字アルファベットに置換
 */


var translateWord = function translateWord(word) {
  var characters = stringToArray(word);
  var translatedWord = '';

  for (var characterIndex = 0; characterIndex < characters.length; characterIndex++) {
    var currentChar = characters[characterIndex];
    var nextChar = characters[characterIndex + 1];

    if (nextChar !== undefined) {
      var twoChars = currentChar + nextChar;
      var matchedTwoChars = TWO_LETTERS_OF_ALPHABET_E_TO_T[twoChars.toLowerCase()];
      if (matchedTwoChars !== undefined) {
        translatedWord += matchedTwoChars;
        characterIndex++;
        continue;
      }
    }

    translatedWord += ONE_LETTER_OF_ALPHABET_E_TO_T[currentChar.toLowerCase()] || currentChar;
  }

  return translatedWord;
};

var translate = function translate(text) {
  var tokens = lexer(text);

  var translatedWords = tokens.map(function (_ref) {
    var type = _ref.type,
        text = _ref.text;
    return type === 'word' ? translateWord(text) : text;
  });

  return translatedWords.join('');
};

module.exports = {
  translate: translate
};