'use strict';

var _require = require('./utils'),
    ONE_LETTER_OF_ALPHABET_T_TO_E = _require.ONE_LETTER_OF_ALPHABET_T_TO_E,
    TOKEN_TYPES = _require.TOKEN_TYPES,
    TWO_LETTERS_OF_ALPHABET_T_TO_E = _require.TWO_LETTERS_OF_ALPHABET_T_TO_E,
    lexer = _require.lexer,
    stringToArray = _require.stringToArray;

var translateWord = function translateWord(word) {
  var characters = stringToArray(word);
  var translatedWord = '';

  for (var characterIndex = 0; characterIndex < characters.length; characterIndex++) {
    var char = characters[characterIndex];
    translatedWord += TWO_LETTERS_OF_ALPHABET_T_TO_E[char] || ONE_LETTER_OF_ALPHABET_T_TO_E[char] || char;
  }

  return translatedWord;
};

var translate = function translate(text) {
  var tokens = lexer(text);

  var translatedWords = tokens.map(function (_ref) {
    var type = _ref.type,
        text = _ref.text;
    return type === 'word' ? translateWord(text) : text;
  });

  return translatedWords.join('');
};

module.exports = {
  translate: translate
};